"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createManyToMany = createManyToMany;

var _reducers = require("./reducers");

var _Relation2 = require("./Relation");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ManyToMany =
/*#__PURE__*/
function (_Relation) {
  _inherits(ManyToMany, _Relation);

  function ManyToMany() {
    _classCallCheck(this, ManyToMany);

    return _possibleConstructorReturn(this, _getPrototypeOf(ManyToMany).apply(this, arguments));
  }

  _createClass(ManyToMany, [{
    key: "createUpsertReducers",
    value: function createUpsertReducers(src) {
      return src.config.providedBy.reduce(function (acc, routine) {
        return _objectSpread({}, acc, _defineProperty({}, routine.SUCCESS, (0, _reducers.reduceArray)(function (state, action, config) {
          var carrier = action.payload;
          var items = carrier[config.name];

          if (!items || items.length === 0) {
            return state;
          }

          var ident = (0, _reducers.getIdentifier)(carrier, src.config);
          var payload = items.map(function (item) {
            var itemIndex = (0, _reducers.getItemIndex)(state, config, (0, _reducers.getIdentifier)(item, config));
            var relatedItems = itemIndex === -1 ? [ident] : state[itemIndex][src.name].concat([ident]);
            return _objectSpread({}, item, _defineProperty({}, src.name, relatedItems));
          });
          return (0, _reducers.upsert)(state, {
            payload: payload
          }, config);
        })));
      }, {});
    }
  }, {
    key: "createEntityProcessor",
    value: function createEntityProcessor(relatedStore) {
      return function (item) {
        var targets = item[relatedStore.name];
        return _objectSpread({}, item, _defineProperty({}, relatedStore.name, targets ? targets.map(function (item) {
          return item instanceof Object ? (0, _reducers.getIdentifier)(item, relatedStore.config) : item;
        }).filter(_reducers.filterUnique) : []));
      };
    }
  }, {
    key: "configureStores",
    value: function configureStores() {
      if (this.target.config.providedBy) {
        this.parent.extend('collectionReducers', this.createUpsertReducers(this.target));
      }

      if (this.parent.config.providedBy) {
        this.target.extend('collectionReducers', this.createUpsertReducers(this.parent));
      }

      this.parent.append('entityProcessors', this.createEntityProcessor(this.target));
      this.target.append('entityProcessors', this.createEntityProcessor(this.parent));
    }
  }, {
    key: "name",
    get: function get() {
      return "manyToMany(".concat(this.connection, ")");
    }
  }]);

  return ManyToMany;
}(_Relation2.Relation);

function getStoreByName(stores, name) {
  var result = stores.find(function (store) {
    return store.name === name;
  });

  if (!result) {
    throw new Error("Cannot find entity store called ".concat(name));
  }

  return result;
}

function createManyToMany(stores) {
  return stores.filter(function (store) {
    return store.config.hasManyToMany;
  }).reduce(function (acc, store) {
    return [].concat(_toConsumableArray(acc), _toConsumableArray(store.config.hasManyToMany.map(function (relatedCollectionName) {
      return new ManyToMany({
        parent: store,
        target: getStoreByName(stores, relatedCollectionName)
      });
    })));
  }, []);
}