"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceArray = reduceArray;
exports.requireIdent = requireIdent;

var _identifiers = require("./identifiers");

function reduceArray(reducer) {
  return function (state, action, config) {
    if (action.payload instanceof Array) {
      return action.payload.reduce(function (acc, payload) {
        return reducer(acc, {
          payload: payload
        }, config);
      }, state);
    }

    return reducer(state, action, config);
  };
}

function requireIdent(reducer) {
  return function (state, action, config) {
    var ident = (0, _identifiers.getIdentifier)(action.payload, config);
    return ident ? reducer(state, action, config, ident) : state;
  };
}