"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterUnique = filterUnique;
exports.filterItem = filterItem;
exports.getItemIndex = getItemIndex;
exports.getIdentifier = getIdentifier;

function filterUnique(item, index, src) {
  return src.indexOf(item) === index;
}

function filterItem(config, ident) {
  return function (item) {
    return getIdentifier(item, config) === ident;
  };
}

function getItemIndex(state, config, ident) {
  return state.findIndex(filterItem(config, ident));
}

function resolvePrimitiveIdentifier(payload) {
  return typeof payload === 'string' ? payload : null;
}

function resolveAttrIdentifier(payload, config) {
  var identAttr = config.identAttr || 'uuid';
  return payload[identAttr] ? payload[identAttr] : resolvePrimitiveIdentifier(payload);
}

function getIdentifier(payload, config) {
  if (!payload) {
    return null;
  }

  return config.identResolver ? config.identResolver(payload) : resolveAttrIdentifier(payload, config);
}