"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createModifyReducer = createModifyReducer;

var _identifiers = require("./identifiers");

var _decorators = require("./decorators");

var _upsert = require("./upsert");

function createModifyReducer(reducer) {
  if (!reducer) {
    throw new Error('You must pass reducer function to the modify reducer');
  }

  return (0, _decorators.reduceArray)((0, _decorators.requireIdent)(function (state, action, config, ident) {
    var itemIndex = (0, _identifiers.getItemIndex)(state, config, ident);
    var item = itemIndex === -1 ? (0, _upsert.constructItem)(config, action.payload) : state[itemIndex];
    var payload = reducer(item, action);
    return (0, _upsert.upsertItem)(state, {
      payload: payload
    }, config, itemIndex);
  }));
}