"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.constructItem = constructItem;
exports.upsertItem = upsertItem;
exports.upsert = void 0;

var _decorators = require("./decorators");

var _identifiers = require("./identifiers");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function processEntity(config, entity) {
  if (config.entityProcessors && config.entityProcessors.length) {
    return config.entityProcessors.reduce(function (acc, processor) {
      return processor(acc);
    }, entity);
  }

  return entity;
}

function constructItem(config, payload) {
  var payloadItem = typeof payload === 'string' ? _defineProperty({}, config.identAttr, payload) : payload;
  return _objectSpread({}, config.initialState, {}, payloadItem);
}

function upsertItem(state, action, config, itemIndex) {
  if (itemIndex === -1) {
    return [].concat(_toConsumableArray(state), [processEntity(config, constructItem(config, action.payload))]);
  }

  var nextState = state.slice();
  nextState[itemIndex] = processEntity(config, action.payload);
  return nextState;
}

var upsert = (0, _decorators.reduceArray)((0, _decorators.requireIdent)(function (state, action, config, ident) {
  return upsertItem(state, action, config, (0, _identifiers.getItemIndex)(state, config, ident));
}));
exports.upsert = upsert;