"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFirstSelectorArg = getFirstSelectorArg;
exports.getSecondSelectorArg = getSecondSelectorArg;
exports.getProp = getProp;
exports.getFlag = getFlag;
exports.createOperationSelector = createOperationSelector;
exports.getOperationProp = getOperationProp;
exports.getOperationFlag = getOperationFlag;

var _reselect = require("reselect");

var _constants = require("./constants");

function getFirstSelectorArg(state, arg1) {
  return arg1;
}

function getSecondSelectorArg(state, arg1, arg2) {
  return arg2;
}

function getProp(item, prop) {
  return item ? item[prop] : null;
}

function getFlag(value) {
  return Boolean(value);
}

function getOperationsState(state) {
  return state[_constants.STORE_OPERATIONS];
}

function createOperationSelector(operationName) {
  return (0, _reselect.createSelector)(getOperationsState, function (operations) {
    return operations[operationName] || null;
  });
}

function getOperationProp(getOperation, prop) {
  return (0, _reselect.createSelector)(getOperation, function () {
    return prop;
  }, getProp);
}

function getOperationFlag(getOperation, prop) {
  return (0, _reselect.createSelector)(getOperationProp(getOperation, prop), getFlag);
}