"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createEntitiesReducer = createEntitiesReducer;

var _redux = require("redux");

var _ManyToMany = require("./ManyToMany");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createEntitiesReducer() {
  for (var _len = arguments.length, stores = new Array(_len), _key = 0; _key < _len; _key++) {
    stores[_key] = arguments[_key];
  }

  var manyToMany = (0, _ManyToMany.createManyToMany)(stores);
  var allStores = [].concat(stores);
  manyToMany.forEach(function (relation) {
    return relation.configureStores();
  });
  allStores.forEach(function (store) {
    return store.initialize();
  });
  return (0, _redux.combineReducers)(allStores.reduce(function (acc, store) {
    return _objectSpread({}, acc, _defineProperty({}, store.name, store.reducer));
  }, {}));
}